/*******************************************************************************
 * NOTE: This source code is free and comes with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2007
 * 
 ******************************************************************************/
const prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService);
var http_request = null;
var devnotes = null;

function setVersion() {
	window.document.getElementById("fbf_version").value = "Feedbackfox " +
					prefs.getCharPref("extensions.feedbackfox.version");
}

function reset() {
	// set version number
	setVersion();
	// load developer notes
	setDevNotes();
	// set the initial state of the "showfbftbarbutton" checkbox
    window.document.getElementById("showfbftbarbutton").checked = 
					prefs.getBoolPref("extensions.feedbackfox.showfbftbarbutton");
	// set the initial state of the "maxfeedbackcount" textfield
	window.document.getElementById("maxfeedbackcount").value = 
					prefs.getCharPref("extensions.feedbackfox.maxfeedbackcount");
	// set the initial state of the characteristic
	var characteristic = prefs.getCharPref("extensions.feedbackfox.characteristic");
	var sellbuy = window.document.getElementById("sellbuy");
	var name = window.document.getElementById("name");
	sellbuy.removeAttribute("selected");
	name.removeAttribute("selected");
	if (characteristic == 'sellbuy') {sellbuy.setAttribute("selected", "true");}
	else {name.setAttribute("selected", "true");}
}

function onAccept() {
	// set showfbftbarbutton
	prefs.setBoolPref("extensions.feedbackfox.showfbftbarbutton", 
					window.document.getElementById("showfbftbarbutton").checked);
	// set maxfeedbackcount
	prefs.setCharPref("extensions.feedbackfox.maxfeedbackcount",
					window.document.getElementById("maxfeedbackcount").value);
	// set characteristic
	var index = window.document.getElementById("characteristic").selectedIndex;
	if (index == 0) {prefs.setCharPref("extensions.feedbackfox.characteristic", "sellbuy")}
	else {prefs.setCharPref("extensions.feedbackfox.characteristic", "name")}
	// close the window.
	window.close();
}

function onCancel() {
	// close the window.
	window.close();
}

function setDevNotes() {
	// request current developer notes
	devnotes = window.document.getElementById('devnotes');
	devnotes.value = "get developer notes...";
	getDevNotes('http://feedbackfox.mozdev.org/devnotes.txt');
}

function getDevNotes(href) {

	http_request = new XMLHttpRequest();
	http_request.timeout = 3; // 3 seconds
	http_request.onreadystatechange = processDevNotes;
	http_request.open('GET', href, true);
	http_request.send(null);
}

function processDevNotes() {
	var currentContent = "";
	if (http_request.readyState == 4) {
		if(http_request.status == 200) {
			var tmp = http_request.responseText;
			tmp = tmp.replace(/<.*>\s*/,"");
			devnotes.value = tmp;
 		}
	}
}

function runInFirefox(path) {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var win = windowManagerInterface.getMostRecentWindow("navigator:browser");

	if (win) {
	  var theTab = win.gBrowser.addTab(path);
	  win.gBrowser.selectedTab = theTab;
	  return;
	}
}

function log(aMessage) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage("Feedbackfox: " + aMessage);
}